/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Hiredis.xs. Do not edit this file, edit Hiredis.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/EV/Hiredis.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include "EVAPI.h"

#include "hiredis.h"
#include "async.h"
#include "libev_adapter.h"
#include "ngx-queue.h"

typedef struct ev_hiredis_s ev_hiredis_t;
typedef struct ev_hiredis_cb_s ev_hiredis_cb_t;

typedef ev_hiredis_t* EV__Hiredis;
typedef struct ev_loop* EV__Loop;

struct ev_hiredis_s {
    struct ev_loop* loop;
    redisAsyncContext* ac;
    SV* error_handler;
    SV* connect_handler;
    struct timeval* connect_timeout;
    struct timeval* command_timeout;
    ngx_queue_t cb_queue; /* for long term callbacks such as subscribe */
};

struct ev_hiredis_cb_s {
    SV* cb;
    ngx_queue_t queue;
    int persist;
};

static void emit_error(EV__Hiredis self, SV* error) {
    if (NULL == self->error_handler) return;

    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(error);
    PUTBACK;

    call_sv(self->error_handler, G_DISCARD);

    FREETMPS;
    LEAVE;
}

static void emit_error_str(EV__Hiredis self, char* error) {
    if (NULL == self->error_handler) return;
    emit_error(self, sv_2mortal(newSVpv(error, 0)));
}

static void remove_cb_queue(EV__Hiredis self) {
    ngx_queue_t* q;
    ev_hiredis_cb_t* cbt;

    while (!ngx_queue_empty(&self->cb_queue)) {
        q   = ngx_queue_last(&self->cb_queue);
        cbt = ngx_queue_data(q, ev_hiredis_cb_t, queue);
        ngx_queue_remove(q);

        SvREFCNT_dec(cbt->cb);
        Safefree(cbt);
    }
}

static void EV__hiredis_connect_cb(redisAsyncContext* c, int status) {
    EV__Hiredis self = (EV__Hiredis)c->data;

    if (REDIS_OK != status) {
        self->ac = NULL;
        emit_error_str(self, c->errstr);
    }
    else {
        if (NULL == self->connect_handler) return;

        dSP;

        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        PUTBACK;

        call_sv(self->connect_handler, G_DISCARD);

        FREETMPS;
        LEAVE;
    }
}

static void EV__hiredis_disconnect_cb(redisAsyncContext* c, int status) {
    EV__Hiredis self = (EV__Hiredis)c->data;
    SV* sv_error;

    if (REDIS_OK == status) {
        self->ac = NULL;
    }
    else {
        sv_error = sv_2mortal(newSVpv(c->errstr, 0));
        self->ac = NULL;
        emit_error(self, sv_error);
    }

    remove_cb_queue(self);
}

static void pre_connect_common(EV__Hiredis self, redisOptions* opts) {
    if (NULL != self->connect_timeout) {
        opts->connect_timeout = self->connect_timeout;
    }
    if (NULL != self->command_timeout) {
        opts->command_timeout = self->command_timeout;
    }
}

static void connect_common(EV__Hiredis self) {
    int r;
    SV* sv_error = NULL;

    self->ac->data = (void*)self;

    r = redisLibevAttach(self->loop, self->ac);
    if (REDIS_OK != r) {
        redisAsyncFree(self->ac);
        self->ac = NULL;
        emit_error_str(self, "connect error: cannot attach libev");
        return;
    }

    redisAsyncSetConnectCallback(self->ac, (redisConnectCallback*)EV__hiredis_connect_cb);
    redisAsyncSetDisconnectCallback(self->ac, (redisDisconnectCallback*)EV__hiredis_disconnect_cb);

    if (self->ac->err) {
        sv_error = sv_2mortal(newSVpvf("connect error: %s", self->ac->errstr));
        redisAsyncFree(self->ac);
        self->ac = NULL;
        emit_error(self, sv_error);
        return;
    }
}

static SV* EV__hiredis_decode_reply(redisReply* reply) {
    SV* res = NULL;

    switch (reply->type) {
        case REDIS_REPLY_STRING:
        case REDIS_REPLY_ERROR:
        case REDIS_REPLY_STATUS:
            res = newSVpvn(reply->str, reply->len);
            break;

        case REDIS_REPLY_INTEGER:
            res = newSViv(reply->integer);
            break;
        case REDIS_REPLY_NIL:
            res = newSV(0);
            break;

        case REDIS_REPLY_ARRAY: {
            AV* av = newAV();
            av_extend(av, (SSize_t)reply->elements);
            size_t i;
            for (i = 0; i < reply->elements; i++) {
                av_push(av, EV__hiredis_decode_reply(reply->element[i]));
            }
            res = newRV_noinc((SV*)av);
            break;
        }
    }

    return res;
}

static void EV__hiredis_reply_cb(redisAsyncContext* c, void* reply, void* privdata) {
    ev_hiredis_cb_t* cbt;
    SV* sv_reply;
    SV* sv_err;

    PERL_UNUSED_VAR(c);

    cbt      = (ev_hiredis_cb_t*)privdata;

    if (NULL == reply) {
        fprintf(stderr, "here error: %s\n", c->errstr);

        dSP;

        ENTER;
        SAVETMPS;

        sv_err = sv_2mortal(newSVpv(c->errstr, 0));

        PUSHMARK(SP);
        PUSHs(&PL_sv_undef);
        PUSHs(sv_err);
        PUTBACK;

        call_sv(cbt->cb, G_DISCARD);

        FREETMPS;
        LEAVE;
    }
    else {
        dSP;

        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        sv_reply = sv_2mortal(EV__hiredis_decode_reply((redisReply*)reply));
        if (((redisReply*)reply)->type == REDIS_REPLY_ERROR) {
            PUSHs(&PL_sv_undef);
            PUSHs(sv_reply);
        }
        else {
            PUSHs(sv_reply);
        }
        PUTBACK;

        call_sv(cbt->cb, G_DISCARD);

        FREETMPS;
        LEAVE;
    }

    if (0 == cbt->persist) {
        SvREFCNT_dec(cbt->cb);
        ngx_queue_remove(&cbt->queue);
        Safefree(cbt);
    }
}

#line 249 "lib/EV/Hiredis.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 393 "lib/EV/Hiredis.c"

XS_EUPXS(XS_EV__Hiredis__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, loop");
    {
	EV__Hiredis	RETVAL;
	char*	class = (char *)SvPV_nolen(ST(0))
;
	EV__Loop	loop;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "EV::Loop")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    loop = INT2PTR(EV__Loop,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::_new",
			"loop", "EV::Loop",
			refstr, ST(1)
		);
	}
;
#line 249 "lib/EV/Hiredis.xs"
{
    PERL_UNUSED_VAR(class);
    Newxz(RETVAL, 1, ev_hiredis_t);
    ngx_queue_init(&RETVAL->cb_queue);
    RETVAL->loop = loop;
}
#line 427 "lib/EV/Hiredis.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "EV::Hiredis", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Hiredis_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	EV__Hiredis	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"EV::Hiredis::DESTROY",
			"self")
;
#line 261 "lib/EV/Hiredis.xs"
{
    self->loop = NULL;
    if (NULL != self->ac) {
        redisAsyncFree(self->ac);
        self->ac = NULL;
    }
    if (NULL != self->error_handler) {
        SvREFCNT_dec(self->error_handler);
        self->error_handler = NULL;
    }
    if (NULL != self->connect_handler) {
        SvREFCNT_dec(self->connect_handler);
        self->connect_handler = NULL;
    }
    if (NULL != self->connect_timeout) {
        Safefree(self->connect_timeout);
        self->connect_timeout = NULL;
    }
    if (NULL != self->command_timeout) {
        Safefree(self->command_timeout);
        self->command_timeout = NULL;
    }

    remove_cb_queue(self);

    Safefree(self);
}
#line 485 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_connect)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, hostname, port= 6379");
    {
	EV__Hiredis	self;
	char*	hostname = (char *)SvPV_nolen(ST(1))
;
	int	port;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::connect",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    port = 6379;
	else {
	    port = (int)SvIV(ST(2))
;
	}
#line 292 "lib/EV/Hiredis.xs"
{
    if (NULL != self->ac) {
        croak("already connected");
        return;
    }

    redisOptions opts = {0};
    pre_connect_common(self, &opts);
    REDIS_OPTIONS_SET_TCP(&opts, hostname, port);
    self->ac = redisAsyncConnectWithOptions(&opts);
    if (NULL == self->ac) {
        croak("cannot allocate memory");
        return;
    }

    connect_common(self);
}
#line 541 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_connect_unix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_connect_unix)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	EV__Hiredis	self;
	const char*	path = (const char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::connect_unix",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;
#line 313 "lib/EV/Hiredis.xs"
{
    if (NULL != self->ac) {
        croak("already connected");
        return;
    }

    redisOptions opts = {0};
    pre_connect_common(self, &opts);
    REDIS_OPTIONS_SET_UNIX(&opts, path);
    self->ac = redisAsyncConnectWithOptions(&opts);
    if (NULL == self->ac) {
        croak("cannot allocate memory");
        return;
    }

    connect_common(self);
}
#line 589 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	EV__Hiredis	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::disconnect",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;
#line 334 "lib/EV/Hiredis.xs"
{
    if (NULL == self->ac) {
        emit_error_str(self, "not connected");
        return;
    }

    redisAsyncDisconnect(self->ac);
}
#line 626 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_connect_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_connect_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout_ms");
    {
	EV__Hiredis	self;
	int	timeout_ms = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::connect_timeout",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;
#line 346 "lib/EV/Hiredis.xs"
{
    if (NULL == self->connect_timeout) {
        Newx(self->connect_timeout, 1, struct timeval);
    }
    self->connect_timeout->tv_sec = timeout_ms / 1000;
    self->connect_timeout->tv_usec = (timeout_ms % 1000) * 1000;
}
#line 664 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_command_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_command_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout_ms");
    {
	EV__Hiredis	self;
	int	timeout_ms = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::command_timeout",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;
#line 357 "lib/EV/Hiredis.xs"
{
    if (NULL == self->command_timeout) {
        Newx(self->command_timeout, 1, struct timeval);
    }
    self->command_timeout->tv_sec = timeout_ms / 1000;
    self->command_timeout->tv_usec = (timeout_ms % 1000) * 1000;
}
#line 702 "lib/EV/Hiredis.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Hiredis_on_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_on_error)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, handler= NULL");
    {
	CV *	RETVAL;
	EV__Hiredis	self;
	CV*	handler;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::on_error",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    handler = NULL;
	else {
	    STMT_START {
		HV *st;
		GV *gvp;
		    SV * const xsub_tmp_sv = ST(1);
		    SvGETMAGIC(xsub_tmp_sv);
		handler = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		    if (!handler) {
			Perl_croak_nocontext("%s: %s is not a CODE reference",
				    "EV::Hiredis::on_error",
				    "handler");
		    }
	    } STMT_END
;
	}
#line 368 "lib/EV/Hiredis.xs"
{
    if (NULL != self->error_handler) {
        SvREFCNT_dec(self->error_handler);
        self->error_handler = NULL;
    }

    if (NULL != handler) {
        self->error_handler = SvREFCNT_inc(handler);
    }

    RETVAL = (CV*)self->error_handler;
}
#line 763 "lib/EV/Hiredis.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Hiredis_on_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_on_connect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, handler= NULL");
    {
	EV__Hiredis	self;
	CV*	handler;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::on_connect",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    handler = NULL;
	else {
	    STMT_START {
		HV *st;
		GV *gvp;
		    SV * const xsub_tmp_sv = ST(1);
		    SvGETMAGIC(xsub_tmp_sv);
		handler = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		    if (!handler) {
			Perl_croak_nocontext("%s: %s is not a CODE reference",
				    "EV::Hiredis::on_connect",
				    "handler");
		    }
	    } STMT_END
;
	}
#line 386 "lib/EV/Hiredis.xs"
{
    if (NULL != handler) {
        if (NULL != self->connect_handler) {
            SvREFCNT_dec(self->connect_handler);
            self->connect_handler = NULL;
        }

        self->connect_handler = SvREFCNT_inc(handler);
    }

    if (self->connect_handler) {
        ST(0) = self->connect_handler;
        XSRETURN(1);
    }
    else {
        XSRETURN(0);
    }
}
#line 835 "lib/EV/Hiredis.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Hiredis_command); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Hiredis_command)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 408 "lib/EV/Hiredis.xs"
    SV* cb;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i;
    ev_hiredis_cb_t* cbt;
#line 855 "lib/EV/Hiredis.c"
	int	RETVAL;
	dXSTARG;
	EV__Hiredis	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "EV::Hiredis")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(EV__Hiredis,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"EV::Hiredis::command",
			"self", "EV::Hiredis",
			refstr, ST(0)
		);
	}
;
#line 415 "lib/EV/Hiredis.xs"
{
    if (items <= 2) {
        croak("Usage: command(\"command\", ..., $callback)");
    }

    cb = ST(items - 1);
    if (!(SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV)) {
        croak("last arguments should be CODE reference");
    }

    if (NULL == self->ac) {
        croak("connect required before call command");
    }

    argc = items - 2;
    Newx(argv, argc, char*);
    Newx(argvlen, argc, size_t);

    for (i = 0; i < argc; i++) {
        argv[i] = SvPV(ST(i + 1), len);
        argvlen[i] = len;
    }

    Newx(cbt, 1, ev_hiredis_cb_t);
    cbt->cb = SvREFCNT_inc(cb);
    ngx_queue_init(&cbt->queue);
    ngx_queue_insert_tail(&self->cb_queue, &cbt->queue);

    if (0 == strcasecmp(argv[0], "subscribe")
        || 0 == strcasecmp(argv[0], "psubscribe")
        || 0 == strcasecmp(argv[0], "monitor")
    ) {
        cbt->persist = 1;
    }
    else {
        cbt->persist = 0;
    }

    RETVAL = redisAsyncCommandArgv(
        self->ac, EV__hiredis_reply_cb, (void*)cbt,
        argc, (const char**)argv, argvlen
    );

    Safefree(argv);
    Safefree(argvlen);
}
#line 920 "lib/EV/Hiredis.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_EV__Hiredis); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_EV__Hiredis)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("EV::Hiredis::_new", XS_EV__Hiredis__new);
        newXS_deffile("EV::Hiredis::DESTROY", XS_EV__Hiredis_DESTROY);
        newXS_deffile("EV::Hiredis::connect", XS_EV__Hiredis_connect);
        newXS_deffile("EV::Hiredis::connect_unix", XS_EV__Hiredis_connect_unix);
        newXS_deffile("EV::Hiredis::disconnect", XS_EV__Hiredis_disconnect);
        newXS_deffile("EV::Hiredis::connect_timeout", XS_EV__Hiredis_connect_timeout);
        newXS_deffile("EV::Hiredis::command_timeout", XS_EV__Hiredis_command_timeout);
        newXS_deffile("EV::Hiredis::on_error", XS_EV__Hiredis_on_error);
        newXS_deffile("EV::Hiredis::on_connect", XS_EV__Hiredis_on_connect);
        newXS_deffile("EV::Hiredis::command", XS_EV__Hiredis_command);

    /* Initialisation Section */

#line 242 "lib/EV/Hiredis.xs"
{
    I_EV_API("EV::Hiredis");
}

#line 973 "lib/EV/Hiredis.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
